#include "allocDynamiqueEtAffichage.h"


void fonctionMalloc(instance_t& instance)
{
	instance.distances = new int *[NBRMAXNOEUDS];
	for (int i = 0; i < NBRMAXNOEUDS; i++)
	{
		instance.distances[i] = new int[NBRMAXNOEUDS];
	}
	instance.quantityCollectable = new int[NBRMAXNOEUDS];
}

void fonctionMalloc(solutionTSP_t &solutionTSP)
{
	solutionTSP.etapesTSP = new int[NBRMAXNOEUDS];
}

void fonctionMalloc(solutionVRP_t &solutionVRP)
{
	solutionVRP.tableauTSP = new solutionTSP_t[NBRMAXNOEUDS];

	for (int i = 0; i < NBRMAXNOEUDS; i++)
	{
		fonctionMalloc(solutionVRP.tableauTSP[i]);
	}
}

void fonctionMalloc(contenantTableauSolutionsTSP_t &contenantTableauSolutionsTSP, int nbrSolutionsTSPprevu)
{
	contenantTableauSolutionsTSP.tableauSolutionsTSP = new solutionTSP_t[nbrSolutionsTSPprevu];

	for (int i = 0; i < nbrSolutionsTSPprevu; i++)
	{
		fonctionMalloc(contenantTableauSolutionsTSP.tableauSolutionsTSP[i]);
	}
}

void fonctionMalloc(contenantTableauSolutionsVRP_t &contenantTableauSolutionsVRP, int nbrSolutionsVRPprevu)
{
	contenantTableauSolutionsVRP.tableauSolutionsVRP = new solutionVRP_t[nbrSolutionsVRPprevu];

	for (int i = 0; i < nbrSolutionsVRPprevu; i++)
	{
		fonctionMalloc(contenantTableauSolutionsVRP.tableauSolutionsVRP[i]);
	}
}

void fonctionFree(instance_t& instance)
{
	if (instance.distances != NULL)
	{
		for (int i = 0; i < NBRMAXNOEUDS; i++)
		{
			if (instance.distances[i] != NULL)
			{
				delete[] instance.distances[i];
			}
		}
		delete[] instance.distances;
	}

	if (instance.quantityCollectable != NULL)
	{
		delete[] instance.quantityCollectable;
	}
}

void fonctionFree(solutionTSP_t &solutionTSP)
{
	if (solutionTSP.etapesTSP != NULL)
	{
		delete[] solutionTSP.etapesTSP;
	}
}

void fonctionFree(solutionVRP_t &solutionVRP)
{
	if (solutionVRP.tableauTSP != NULL)
	{
		for (int i = 0; i < NBRMAXNOEUDS; i++)
		{
			fonctionFree(solutionVRP.tableauTSP[i]);
		}
		delete[] solutionVRP.tableauTSP;
	}
}

void fonctionFree(contenantTableauSolutionsTSP_t &contenantTableauSolutionsTSP, int nbrSolutionsTSPprevu)
{
	if (contenantTableauSolutionsTSP.tableauSolutionsTSP != NULL)
	{
		for (int i = 0; i < nbrSolutionsTSPprevu; i++)
		{
			fonctionFree(contenantTableauSolutionsTSP.tableauSolutionsTSP[i]);
		}
		delete[] contenantTableauSolutionsTSP.tableauSolutionsTSP;
	}
}

void fonctionFree(contenantTableauSolutionsVRP_t &contenantTableauSolutionsVRP, int nbrSolutionsVRPprevu)
{
	if (contenantTableauSolutionsVRP.tableauSolutionsVRP != NULL)
	{
		for (int i = 0; i < nbrSolutionsVRPprevu; i++)
		{
			fonctionFree(contenantTableauSolutionsVRP.tableauSolutionsVRP[i]);
		}
		delete[] contenantTableauSolutionsVRP.tableauSolutionsVRP;
	}
}



void copierSolutionTSP(solutionTSP_t &solutionTSPreceveuse, solutionTSP_t solutionTSPcopied)
{
	solutionTSPreceveuse.nomSolutionTSP = solutionTSPcopied.nomSolutionTSP;
	solutionTSPreceveuse.coutTotalTSP = solutionTSPcopied.coutTotalTSP;
	solutionTSPreceveuse.quantityTotaleTSP = solutionTSPcopied.quantityTotaleTSP;
	solutionTSPreceveuse.nbrNoeudsTSP = solutionTSPcopied.nbrNoeudsTSP;

	for (int i = 0; i < NBRMAXNOEUDS /*= solutionTSPcopied.nbrNoeudsTSP + 1*/; i++)
	{
		solutionTSPreceveuse.etapesTSP[i] = solutionTSPcopied.etapesTSP[i];
	}
}

void copierSolutionVRP(solutionVRP_t &solutionVRPreceveuse, solutionVRP_t solutionVRPcopied)
{
	solutionVRPreceveuse.nomSolutionVRP = solutionVRPcopied.nomSolutionVRP;
	solutionVRPreceveuse.nbrTourneesVRP = solutionVRPcopied.nbrTourneesVRP;
	solutionVRPreceveuse.coutTotalVRP = solutionVRPcopied.coutTotalVRP;
	solutionVRPreceveuse.quantityTotaleVRP = solutionVRPcopied.quantityTotaleVRP;

	for (int i = 0; i < NBRMAXNOEUDS; i++)
	{
		copierSolutionTSP(solutionVRPreceveuse.tableauTSP[i], solutionVRPcopied.tableauTSP[i]);
	}
}

void copierContenantTableauSolutionTSP(contenantTableauSolutionsTSP_t &contenantTableauSolutionsTSPreceveuse, contenantTableauSolutionsTSP_t contenantTableauSolutionsTSPcopied)
{
	contenantTableauSolutionsTSPreceveuse.nomTableauSolutionsTSP = contenantTableauSolutionsTSPcopied.nomTableauSolutionsTSP;
	contenantTableauSolutionsTSPreceveuse.nbrSolutionsTSP = contenantTableauSolutionsTSPcopied.nbrSolutionsTSP;

	for (int i = 0; i < contenantTableauSolutionsTSPreceveuse.nbrSolutionsTSP; i++)
	{
		copierSolutionTSP(contenantTableauSolutionsTSPreceveuse.tableauSolutionsTSP[i], contenantTableauSolutionsTSPcopied.tableauSolutionsTSP[i]);
	}
}

void copierContenantTableauSolutionVRP(contenantTableauSolutionsVRP_t &contenantTableauSolutionsVRPreceveuse, contenantTableauSolutionsVRP_t contenantTableauSolutionsVRPcopied)
{
	contenantTableauSolutionsVRPreceveuse.nomTableauSolutionsVRP = contenantTableauSolutionsVRPcopied.nomTableauSolutionsVRP;
	contenantTableauSolutionsVRPreceveuse.nbrSolutionsVRP = contenantTableauSolutionsVRPcopied.nbrSolutionsVRP;

	for (int i = 0; i < contenantTableauSolutionsVRPreceveuse.nbrSolutionsVRP; i++)
	{
		copierSolutionVRP(contenantTableauSolutionsVRPreceveuse.tableauSolutionsVRP[i], contenantTableauSolutionsVRPcopied.tableauSolutionsVRP[i]);
	}
}






void afficherSommetsTSP(solutionTSP_t solutionTSP)
{
	std::cout << "Voici les sommets de " << solutionTSP.nomSolutionTSP << "\n";

	for (int i = 0; i <= solutionTSP.nbrNoeudsTSP + 1; i++)
	{
		std::cout << solutionTSP.etapesTSP[i] << " ";
	}
	std::cout << "\n";
}



void afficherTourneesDeSolutionVRP(solutionVRP_t solutionVRP)
{
	for(int i = 0; i < solutionVRP.nbrTourneesVRP; i++)
	{
		std::cout << "Tournée d'indice " << i << " --> Nombre de sommets = " << solutionVRP.tableauTSP[i].nbrNoeudsTSP << "; Coût Total = " << solutionVRP.tableauTSP[i].coutTotalTSP << " et Quantité Collectée = " << solutionVRP.tableauTSP[i].quantityTotaleTSP << "\n	";
		for (int j = 0; j <= solutionVRP.tableauTSP[i].nbrNoeudsTSP + 1; j++)
		{
			std::cout << solutionVRP.tableauTSP[i].etapesTSP[j] << " ";
		}
		std::cout << "\n\n";
	}
}




void afficherSolutionTSP(solutionTSP_t solutionTSP)
{
	std::string espace = "";
	int sizeNomTSP = (int)solutionTSP.nomSolutionTSP.size();
	for (int i = 0; i < TAILLEPLUSGRANDNOMSOLUTION - sizeNomTSP; i++)
	{
		espace += " ";
	}
	std::cout << "Coût total " << solutionTSP.nomSolutionTSP << " : " << espace << solutionTSP.coutTotalTSP << "; nbr sommets : " << solutionTSP.nbrNoeudsTSP << "; quantités : " << solutionTSP.quantityTotaleTSP << "\n";
}

void afficherSolutionVRP(solutionVRP_t solutionVRP)
{
	std::string espace = "";
	int sizeNomVRP = (int)solutionVRP.nomSolutionVRP.size();
	for (int i = 0; i < TAILLEPLUSGRANDNOMSOLUTION - sizeNomVRP; i++)
	{
		espace += " ";
	}
	std::cout << "Coût total " << solutionVRP.nomSolutionVRP << " : " << espace << solutionVRP.coutTotalVRP << "; nbr tournées : " << solutionVRP.nbrTourneesVRP << "; quantités : " << solutionVRP.quantityTotaleVRP << "\n";
}



void afficherContenantTableauSolutionsTSP(contenantTableauSolutionsTSP_t contenantTableauSolutionsTSP)
{
	std::cout << "Voici " << contenantTableauSolutionsTSP.nomTableauSolutionsTSP << " : \n";
	for (int i = 0; i < contenantTableauSolutionsTSP.nbrSolutionsTSP; i++)
	{
		std::cout << "	";
		afficherSolutionTSP(contenantTableauSolutionsTSP.tableauSolutionsTSP[i]);
	}
	std::cout << "\n";
}

void afficherContenantTableauSolutionsVRP(contenantTableauSolutionsVRP_t contenantTableauSolutionsVRP)
{
	std::cout << "Voici " << contenantTableauSolutionsVRP.nomTableauSolutionsVRP << " : \n";
	for (int i = 0; i < contenantTableauSolutionsVRP.nbrSolutionsVRP; i++)
	{
		std::cout << "	";
		afficherSolutionVRP(contenantTableauSolutionsVRP.tableauSolutionsVRP[i]);
	}
	std::cout << "\n";
}

