#ifndef OUTILS_H
#define OUTILS_H

#include "general.h"


// PRINCIPALES FONCTIONS

void instanciation(std::string nomFichier, instance_t& instance);


void evaluerTSP(instance_t instance, solutionTSP_t& solutionTSP, bool affichage);
void evaluerVRP(instance_t instance, solutionVRP_t& solutionVRP, bool affichage);


void productionDeToursGeantsPourSPLIT(contenantTableauSolutionsTSP_t& contenantTableauSolutionsTSPpourSPLIT, instance_t instance);
    void constructionTSPplusProcheVoisins(instance_t instance, solutionTSP_t& solutionTSP);
    void constructionTSPplusProchesVoisinsRandomized(instance_t instance, solutionTSP_t& solutionTSP);
    void constructionTSPavecTousLesSommetsIndiceCroissant(instance_t instance, solutionTSP_t& solutionTSP);
    void constructionTSPcheapestInsertion(instance_t instance, solutionTSP_t& solutionTSP);
    void constructionTSPplusLointainVoisin(instance_t instance, solutionTSP_t& solutionTSP);
    void constructionTSPrandom(instance_t instance, solutionTSP_t& solutionTSP);
    
    void RL_2optTSP(instance_t instance, solutionTSP_t& solutionTSP);
    void RL_deplacementSommetTSP(instance_t instance, solutionTSP_t& solutionTSP);


void productionDeVRPpour1erCycleOpti(contenantTableauSolutionsTSP_t& contenantTableauSolutionsTSPpourSPLIT, contenantTableauSolutionsVRP_t& contenantTableauSolutionsVRPpourOPTI, instance_t instance);
    void SPLIT(instance_t instance, solutionTSP_t& solutionTSP, solutionVRP_t& solutionVRP);
    void constructionVRPsommetsLointainsPuisCheapestInsertion(instance_t instance, solutionVRP_t& solutionVRP);


void procedure1erCycleOptimisation(instance_t instance, contenantTableauSolutionsVRP_t contenantTableauSolutionsVRPpourOpti, contenantTableauSolutionsVRP_t& meilleuresSolutionsVRPtrouvees);
    void procedureOptiCompleteSolutionVRP(instance_t instance, solutionVRP_t& solutionVRP);
        void RL_2optVRP(instance_t instance, solutionVRP_t& solutionVRP);
        void RL_deplacementSommetVRP(instance_t instance, solutionVRP_t& solutionVRP);
        bool fusionTourneesDansVRP(instance_t instance, solutionVRP_t& solutionVRP);


void procedure2emeCycleOptimisation(instance_t instance, contenantTableauSolutionsVRP_t contenantTableauSolutionsVRPpourOpti, contenantTableauSolutionsVRP_t& meilleuresSolutionsVRPtrouvees);
    void effectuerRegressionRecursive(instance_t instance, solutionVRP_t solutionVRPcourante, solutionVRP_t& solutionVRPmeilleureTrouvee, int profondeurActuelle, bool & continuer);
       void effectuerRegression(instance_t instance, solutionVRP_t solutionVRP);





// "BOITE A OUTILS"" 

void trierTourneesVRPparQuantityTotaleTSPdecroissante(solutionVRP_t& solutionVRP);
void triCoutCroissantContenantTableauSolutionsTSP(contenantTableauSolutionsTSP_t& contenantTableauSolutionsTSP);
void triCoutCroissantContenantTableauSolutionsVRP(contenantTableauSolutionsVRP_t& contenantTableauSolutionsVRP);


int indiceNoeudPlusProcheVoisinNotVisited(instance_t instance, solutionTSP_t& solutionTSP, int indiceNoeudCourant);
int indiceNoeudPlusLointainVoisinNotVisited(instance_t instance, solutionTSP_t& solutionTSP, int indiceNoeudCourant);

int min(int a, int b);
int max(int a, int b);

void trouverPermutationFaisableDansSolutionVRP(instance_t instance, solutionVRP_t& solutionVRP, int& tirageTournee1, int& tirageTournee2, int& tirageIndiceSommetTournee1, int& tirageIndiceSommetTournee2);

void goPermuterDansSolutionTSP(solutionTSP_t& solutionTSP, int indiceA, int indiceB);
bool permuterSiRentable(instance_t instance, int indice1, int indice2, solutionTSP_t& solutionTSP);
bool inverserSiRentable(instance_t instance, int indice1, int indice2, solutionTSP_t& solutionTSP);
bool permuterSommetsEtOptimiserTSPsiFaisableEtRentable(instance_t instance, solutionTSP_t& solutionTSP1, solutionTSP_t& solutionTSP2, int indiceSommet1, int indiceSommet2);
bool deplacerSommetDeTournee1DansTournee2EtOptimiserSiFaisableEtRentable(instance_t instance, solutionTSP_t& solutionTSP1, solutionTSP_t& solutionTSP2, int indiceSommetTournee, int indiceInsertionSommet);
bool deplacerSommetDansTourneeEtOptimiserSiRentable(instance_t instance, solutionTSP_t& solutionTSP, int indiceSommetDeplaced, int indiceInsertionSommet);


void enleverDoublonsEtAjouterInverses(contenantTableauSolutionsTSP_t& contenantTableauSolutionsTSPpourSPLIT);
bool solutionTSP1_equalOrInversed_SolutionTSP2(solutionTSP_t solutionTSP1, solutionTSP_t solutionTSP2);

#endif